// #autoload
// #name = ObserverKey
// #version = 1.2
// #date = March 31, 2002
// #author = Misanthropic aka. EXoCiDe
// #warrior = Misanthropic
// #email = exocide@x-mail.net
// #web = http://www.angelfire.com/sc3/exocide
// #web = http://exocide.vsn.nu/
// #description = Allows you to become an observer with the press of a button. Now has a quick respawn function, and an option throw a grenade and/or mine right before you do.
// #credit = The lamers out there who cheat death this way, and me for being lame by making it easier :) Also thanks to Please_kill_me for the grenade/mine idea.
// #config = ObserverKeyGui
// #readme = ObserverKey_changes.txt

if(!isObject(ObserverKey)){
	if(isFile("prefs/Misanthropic.cs") && !$Misanthropic.cs){
		exec("prefs/Misanthropic.cs");
		$Misanthropic.cs = true;
	}
	if(!$Misanthropic::ObserverKey::Init){
		$Misanthropic::ObserverKey::Init = true;
		$Misanthropic::ObserverKey::Grenade = false;
		$Misanthropic::ObserverKey::Mine = false;
	}
	new ScriptObject(ObserverKey)
	{
		class = ObserverKey;
	};
}



package ObserverKey {

	function ObserverKey::setup(%this) {
		if(%this.setup)
			return;

		new GuiControl(ObserverKeyGui) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "640 480";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellPaneCtrl() {
				profile = "ShellPaneProfile";
				horizSizing = "center";
				vertSizing = "center";
				position = "214 181";
				extent = "212 118";
				minExtent = "48 92";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "ObserverKey";
				longTextBuffer = "0";
				maxLength = "255";
				noTitleBar = "0";

				new ShellFieldCtrl() {
					profile = "ShellFieldProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "22 30";
					extent = "170 68";
					minExtent = "16 18";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
				};

				new ShellToggleButton(ObserverKeyGuiGrenade) {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "36 37";
					extent = "140 30";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$Misanthropic::ObserverKey::Grenade";
					helpTag = "0";
					text = "Throw a grenade ";
					longTextBuffer = "0";
					maxLength = "255";
				};

				new ShellToggleButton(ObserverKeyGuiMine) {
					profile = "ShellRadioProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "36 61";
					extent = "140 30";
					minExtent = "26 27";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "$Misanthropic::ObserverKey::Mine";
					helpTag = "0";
					text = "Drop a mine ";
					longTextBuffer = "0";
					maxLength = "255";
				};
			};
		};

		ObserverKeyGuiGrenade.setValue($Misanthropic::ObserverKey::Grenade);
		ObserverKeyGuiMine.setValue($Misanthropic::ObserverKey::Mine);

		%this.setup = true;
	}

	function OptionsDlg::onWake(%this){
		if(!$ObserverMap)
		{
			$RemapName[$RemapCount]="Become An Observer";
			$RemapCmd[$RemapCount]="Observe";
			$RemapCount++;
			$RemapName[$RemapCount]="Change Your Team";
			$RemapCmd[$RemapCount]="ChangeTeam";
			$RemapCount++;
			$RemapName[$RemapCount]="ObserverKey Quick Respawn";
			$RemapCmd[$RemapCount]="ObserverKeyActiv";
			$RemapCount++;
			$ObserverMap = true;
		}
		parent::onWake(%this);
	}

	function ObserverKeyGrenade(){
		use("Grenade");
		use("FlashGrenade");
		use("ConcussionGrenade");
	}

	function ObserverKeyMine(){
		use("Mine");
	}

	function Observe(%val){
		if(!%val)
			return;
		else
			commandToServer('ClientMakeObserver');
	}

	function SwitchTeam(){
		commandToServer('ClientJoinTeam', -1, true);
	}

	function ChangeTeam(%val){
		if(!%val)
			return;
		else
			commandToServer('ClientJoinTeam', -1, true);
	}

	function ObserverKeyRespawn(){
		SwitchTeam();
		schedule(50, 0, "SwitchTeam");
	}

	function ObserverKeyActiv(%val){
		if(!%val)
			return;
		else if(!$Misanthropic::ObserverKey::Grenade && !$Misanthropic::ObserverKey::Mine){
			ObserverKeyRespawn();
		}
		else if($Misanthropic::ObserverKey::Grenade && !$Misanthropic::ObserverKey::Mine){
			ObserverKeyGrenade();
			schedule(100, 0, "ObserverKeyRespawn");
		}
		else if(!$Misanthropic::ObserverKey::Grenade && $Misanthropic::ObserverKey::Mine){
			ObserverKeyMine();
			schedule(100, 0, "ObserverKeyRespawn");
		}
		else if($Misanthropic::ObserverKey::Grenade && $Misanthropic::ObserverKey::Mine){
			ObserverKeyGrenade();
			schedule(100, 0, "ObserverKeyMine");
			schedule(200, 0, "ObserverKeyRespawn");
		}
	}

	function DispatchLaunchMode(){
		parent::DispatchLaunchMode();
		ObserverKey.setup();
	}

	function quit(){
		if(!$PrefsSaved){
			export("$Misanthropic::*", "prefs/Misanthropic.cs", false);
			$PrefsSaved = true;
		}
		parent::quit();
	}
};

activatePackage(ObserverKey);

if($AutoloadExecuted)
	ObserverKey.setup();